#!/usr/bin/Rscript
#message(getwd());

test_info <- 
    base:::read.table("plugins_hosts_services.tab",
                      sep       = "\t",
                      header    = TRUE);

command_line_arguments <- 
    base:::paste(test_info$Nagios.plugin, "-h", test_info$host);
command_line_arguments <- c(command_line_arguments,
                            test_info[,5L:ncol(test_info)]);

## test_results has a value equal to the exit status of the scripts with arguments command_line_arguments run.

test_results <- 
    base:::integer(length = base:::length(command_line_arguments));
test_stdout <- 
    base:::character(length = base:::length(command_line_arguments));
#test_stderr 
#   <- character(length = length(command_line_arguments));
## X- stderr output cannot be caught separately yet due to R implementation issue

for (test_index in 1L:base:::length(command_line_arguments))
{
    base:::message(base:::paste0("Running test ", test_index));

    arg_set <-
        command_line_arguments[test_index];

    test_output <-
        system2(command = "python2",
                args    = arg_set,
                stdout  = TRUE,
                stderr  = TRUE);

    ## Fetch exit status codes.  
    if(!base:::is.null(base:::attr(test_output, "status"))) {
        test_results[test_index] <- 
            base:::as.integer(attr(test_output, "status"));
    } else { 
        test_results[test_index] <- 
            0L;
    };

    test_stdout[test_index] <-
        base:::paste0(test_output, 
                      sep = "\n", 
                      collapse = "\n");

    # browser();
}

test_results_df <- 
    base:::data.frame(description             = test_info$service,
                      command_line_arguments  = command_line_arguments, 
                      test_results            = test_results, 
                      test_stdout             = test_stdout,
                      stringsAsFactors        = FALSE);

test_results_file_path <- 
    "/tmp/test_results.tab";

base:::write.table(test_results_df,
                   file            = test_results_file_path,
                   col.names       = TRUE,
                   row.names       = FALSE,
                   sep             = "\t");

base:::message(base:::paste0("Written test results to TAB-separated table at '", test_results_file_path, "' ..."));